/*
 * Copyright (C) 2012 Marcus Overhagen <marcus@overhagen.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 */
#include <inttypes.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <string.h>
#include "util.h"
#include "uart.h"
#include "spi.h"
#include "LEDStrip.h"

int main()
{

    uart_init();
    printf("\n\n\nHallo!\n");
/*
for(;;) {

	char s[20];
    printf("Farbe? ");

	fgets(s, sizeof(s), stdin);
	if (strcmp(s, "rot\n") == 0) {
		PORTC = _BV(PC7);
	}
	if (strcmp(s, "blau\n") == 0) {
		PORTC = _BV(PC6);
	}
	if (strcmp(s, "beide\n") == 0) {
		PORTC = _BV(PC6) | _BV(PC7);
	}

delay(500);
}
*/

spi_init();

LEDStrip strip(40);
delay(500);


for (;;)
{
start:
	strip.ColorFill(red, 1000);
	strip.ColorFill(green, 1000);
	strip.ColorFill(blue, 1000);
	strip.ColorFill(white, 1000);
	strip.ColorFill(black, 1000);
	strip.Wipe(red, 30);
	strip.WipeReverse(white, 30);
	strip.Wipe(green, 30);
	strip.WipeReverse(orange, 30);
	strip.Wipe(blue, 30);
//goto start;
/*
	strip.BlockColorChase(green, red, 3, 4, 100, 2);
	strip.BlockColorChase(blue, white, 4, 8, 100, 2);

	strip.BlockColorChaseReverse(green, red, 3, 4, 100, 2);
	strip.BlockColorChaseReverse(blue, white, 4, 8, 100, 2);
*/
	strip.KnightRider(black, red, 16, 7, 270, 2);
//	strip.KnightRider(black, white, 9, 12, 180, 1);
//	strip.KnightRider(black, blue, 9, 12, 180, 1);

	strip.FadeIn(white, 50);
	strip.FadeOut(white, 50);
	strip.FadeIn(red, 50);
	strip.FadeOut(red, 50);
	strip.FadeIn(blue, 50);
	strip.FadeOut(blue, 50);
	strip.FadeIn(green, 50);
	strip.FadeOut(green, 50);
	strip.FadeIn(magenta, 50);
	strip.FadeOut(magenta, 50);
	strip.FadeIn(orange, 50);
	strip.FadeOut(orange, 50);

	strip.Cycle(200, 100,1);

	strip.ColorChase(black, white, 10);
	strip.ColorChase(black, red, 10);
	strip.ColorChase(black, green, 10);
	strip.ColorChase(black, blue, 10);
	strip.ColorChase(black, yellow, 10);
	strip.ColorChase(black, cyan, 10);
	strip.ColorChase(black, magenta, 10);
	strip.ColorChase(black, orange, 10);

	strip.Rainbow(10, 150, 4);
	strip.RainbowReverse(10, 150, 4);

	strip.ColorFill(white, 500);
	strip.ColorFill(red, 500);
	strip.ColorFill(green, 500);
	strip.ColorFill(blue, 500);
	strip.ColorFill(yellow, 500);
	strip.ColorFill(cyan, 500);
	strip.ColorFill(magenta, 500);
	strip.ColorFill(orange, 500);

	strip.ColorChaseReverse(black, white, 10);
	strip.ColorChaseReverse(black, red, 10);
	strip.ColorChaseReverse(black, green, 10);
	strip.ColorChaseReverse(black, blue, 10);
	strip.ColorChaseReverse(black, yellow, 10);
	strip.ColorChaseReverse(black, cyan, 10);
	strip.ColorChaseReverse(black, magenta, 10);
	strip.ColorChaseReverse(black, orange, 10);


	strip.ColorChase(black, white, 10);
	strip.ColorChaseReverse(black, white, 10);

	strip.ColorFill(black, 1000);

	strip.Rainbow(200, 50, 2);
	strip.RainbowReverse(200, 50, 2);

	strip.ColorFill(black, 3000);


/*
strip.ColorFill(black, 1000);

strip.Rainbow(3, 100, 20);
strip.RainbowReverse(3, 100, 20);


	strip.Cycle(200, 100,2);
//	strip.CycleReverse(200, 100,2);

	strip.Rainbow(100, 50, 20);

	strip.ColorFill(black, 1000);
*/
//strip.RainbowReverse(3, 1000);
//strip.ColorFill(black, 3000);
//strip.Cycle(3, 1000);
//strip.CycleReverse(3, 1000);
//strip.ColorFill(black, 3000);

}

    return 0;
}

